package example.cannotmarshal;

import java.io.IOException;
import java.io.PrintWriter;

import java.lang.Exception;

import example.cannotmarshal.EntityBeanA.EntityBeanARemoteHome;
import example.cannotmarshal.EntityBeanA.EntityBeanARemote;

import example.cannotmarshal.EntityBeanB.EntityBeanBRemoteHome;
import example.cannotmarshal.EntityBeanB.EntityBeanBRemote;


// PURPLE WIRE

//import javax.ejb.*;

// END PURPLE WIRE

import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;

import java.rmi.RemoteException;

import javax.rmi.PortableRemoteObject;

import java.util.Properties;

/**
 * @web.servlet
 *    name="Controller"
 *
 * @web.servlet-mapping
 *    url-pattern="/controller/*"
 */
public class Controller extends HttpServlet
{

    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException, ServletException {
        processRequest(request, response);
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws IOException, ServletException {
        processRequest(request, response);
    }

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

	PrintWriter printWriter = null;

	try {

	    printWriter = response.getWriter();	

	    // PURPLE WIRE

	    printWriter.println("The servlet is successfully running.<br>");
	    String actionParameter = request.getParameter("action");
	    printWriter.println("The actionParameter variable is: " + actionParameter + "<br>");

	    printWriter.println("Now we are going to try to create the EJBs.<br>");

	    Properties properties = new Properties();
	    Context jndiContext = new InitialContext(properties);

	    printWriter.println("Looking up EntityBeanARemoteHome.<br>");

	    Object entityBeanARemoteHomeRef = jndiContext.lookup("java:global/cannotmarshal/cannotmarshal-ejb/EntityBeanA!example.cannotmarshal.EntityBeanA.EntityBeanARemoteHome");

	    printWriter.println("Narrowing up EntityBeanARemoteHome.<br>");

	    EntityBeanARemoteHome entityBeanARemoteHome = (EntityBeanARemoteHome)PortableRemoteObject.narrow(entityBeanARemoteHomeRef, EntityBeanARemoteHome.class);

	    printWriter.println("Finding EntityBeanARemote<br>");

	    EntityBeanARemote entityBeanARemote = entityBeanARemoteHome.findByPrimaryKey(1);

	    printWriter.println("found EntityBeanARemote<br>");

	    printWriter.println("column 1: " + entityBeanARemote.getColumn1() + "<br>");
	    printWriter.println("column 2: " + entityBeanARemote.getColumn2() + "<br>");

	    Object entityBeanBRemoteHomeRef = jndiContext.lookup("java:global/cannotmarshal/cannotmarshal-ejb/EntityBeanB!example.cannotmarshal.EntityBeanB.EntityBeanBRemoteHome");
	    EntityBeanBRemoteHome entityBeanBRemoteHome = (EntityBeanBRemoteHome)PortableRemoteObject.narrow(entityBeanBRemoteHomeRef, EntityBeanBRemoteHome.class);
	    EntityBeanBRemote entityBeanBRemote = entityBeanBRemoteHome.findByPrimaryKey(1);
	    printWriter.println("column 1: " + entityBeanBRemote.getColumn3() + "<br>");
	    printWriter.println("column 2: " + entityBeanBRemote.getColumn4() + "<br>");

	    entityBeanARemote.returnPlainOldJavaObject();

	    printWriter.println("returned the plain old java object<br>");

	    // END PURPLE WIRE

	} catch (Exception e) {

	    printWriter.println("An exception was raised:");
	    printWriter.println(e.getMessage());
	    e.printStackTrace();

	} finally {

	    // ?NEED? Maybe we don't need anything here.
	    
	}
    }

}
